<div class="row m-0 tb-scroll"  [perfectScrollbar]>
  <table class="table card-table price-table">
    <thead >
      <tr class="price-tr">
        <th>
          <!-- <mat-checkbox ></mat-checkbox> -->
          <!-- <label class="custom-control custom-checkbox mb-0">
            <input class="custom-control-input " type="checkbox">
            <span class="custom-control-label"></span>
          </label> -->
        </th>
        <th style="min-width:220px;" class="price-title-table">
          <div class="cursor" (click)="sort_products('initial_checked_count')">
         
            Category
            <span *ngIf="current_sort_order.field == 'initial_checked_count'"><i class="las pl-2"
              [ngClass]="(current_sort_order.sortorder)?'la-arrow-down':'la-arrow-up'"></i></span>
          <span *ngIf="current_sort_order.field != 'initial_checked_count'"><i class="las pl-2 la-arrows-alt-v"></i></span>
          </div>
        </th>
        <th class="price-title-table text-right info-width">
          <div class="cursor" (click)="sort_products('revenue_change')">
            <span *ngIf="current_sort_order.field == 'revenue_change'"><i class="las pl-2"
              [ngClass]="(current_sort_order.sortorder)?'la-arrow-down':'la-arrow-up'"></i></span>
          <span *ngIf="current_sort_order.field != 'revenue_change'"><i class="las pl-2 la-arrows-alt-v"></i></span>
            Revenue Change
      
          </div>
        </th>
        <th class="price-title-table text-right info-width">
          <div class="cursor" (click)="sort_products('profit_change')">
            <span *ngIf="current_sort_order.field == 'profit_change'"><i class="las pl-2"
              [ngClass]="(current_sort_order.sortorder)?'la-arrow-down':'la-arrow-up'"></i></span>
          <span *ngIf="current_sort_order.field != 'profit_change'"><i class="las pl-2 la-arrows-alt-v"></i></span>
            Profit Change
          
          </div>
          <!-- <span><i class="las la-long-arrow-alt-down pl-2"></i></span> -->
        </th>
        <th class="price-title-table text-right info-width">
          <div class="cursor" (click)="sort_products('margin_change')">
            <span *ngIf="current_sort_order.field == 'margin_change'"><i class="las pl-2"
              [ngClass]="(current_sort_order.sortorder)?'la-arrow-down':'la-arrow-up'"></i></span>
          <span *ngIf="current_sort_order.field != 'margin_change'"><i class="las pl-2 la-arrows-alt-v"></i></span>
            Margin Change
          
          </div>
        </th>

        <th class="price-title-table text-right info-width">
          <div class="cursor" (click)="sort_products('units_change')">
            <span *ngIf="current_sort_order.field == 'units_change'"><i class="las pl-2"
              [ngClass]="(current_sort_order.sortorder)?'la-arrow-down':'la-arrow-up'"></i></span>
          <span *ngIf="current_sort_order.field != 'units_change'"><i class="las pl-2 la-arrows-alt-v"></i></span>
            Unit Change
         
          </div>
        </th>
        
      </tr>
    </thead>
    <tbody>
      <ng-container *ngFor="let gr_data of grid_data| orderBy: current_sort_order.field:current_sort_order.sortorder;">
          <ng-template [ngTemplateOutlet]="nodeTemplateRef" [ngTemplateOutletContext]="{ $implicit: gr_data }">
          </ng-template>
      </ng-container>
    </tbody>
  </table>
</div>

<!-- Define the recursive template. -->
<ng-template #nodeTemplateRef let-node>
          <tr *ngIf="node.child.length>0" class="price-tr" [ngClass]="selected_product == node.ind_key ?'table-row-active': ''" [hidden]="node.hide">
            <td style="max-width: 20px;" class="pr-check">
              <mat-checkbox  [checked]='node.checked==1' [indeterminate]="node.checked==2" (click)="selection_changed($event,node)" *ngIf="node.level>0"></mat-checkbox>
              <!-- <label class="custom-control custom-checkbox mb-0">
                <input class="custom-control-input" type="checkbox">
                <span class="custom-control-label"></span>
              </label> -->
            </td>
      
            <td class="normal-calss" style="min-width:220px;">
              <div class="d-flex cursor align-items-center"  [style.paddingLeft.px]="(node.level-1)*30">
               <div>
                <i (click)="node.expand=!node.expand;" class="las  text-gray55 f-14 mr-2 nodeArrow" [ngClass]="node.expand ? 'la-angle-down' :'la-angle-right'" *ngIf="node.level<level_limit && node.level>0" ></i>
               </div>
                <div (click)="product_selection(node)" class="d-flex align-items-center" [style.paddingLeft.px]="(node.level-1)*7">
                  <span class="f-14 WSF fw-500 nodeName">{{node.name}}</span>
                  <div  class="text-gray77 f-12 pl-2 WSF">
                    ({{node.checked_count}}/{{node.count}})</div>
                </div>
              </div>
            </td>

                        <td>
                          <div [ngClass]="{'green-class': node.revenue_sign == '+' , 'red-class':  node.revenue_sign == '-'}" class="d-flex justify-content-end">
                            {{node.f_revenue_change}}
                            <div> 
                              <i class="pl-1 fa "
                                [ngClass]="{'fa-caret-down': node.revenue_sign == '-', 'fa-caret-up': node.revenue_sign == '+'}"></i></div>
                            <div style="position: relative;" class="pop_chart">
                              <i class="las la-info-circle text-gray77 pl-2" placement="left" [ngbPopover]="info_tooltip_3"
                                triggers="mouseenter:mouseleave"></i>
                            </div>
                            <ng-template #info_tooltip_3>
                              <ng-container [ngTemplateOutlet]="tooltip_table"
                                [ngTemplateOutletContext]="{sign:node.revenue_sign, current:node.f_current_revenue, expected:node.f_expected_revenue, current_percentage: node.current_revenue_percentage, expected_percentage: node.expected_revenue_percentage}">
                              </ng-container>
                            </ng-template>
                          </div>
                        </td>
                        <td>
                          <div [ngClass]="{'green-class': node.profit_sign == '+' , 'red-class':  node.profit_sign == '-'}" class="d-flex justify-content-end">
                            {{node.f_profit_change}}
                            <div> <i class="pl-1 fa "
                                [ngClass]="{'fa-caret-down': node.profit_sign == '-', 'fa-caret-up': node.profit_sign == '+'}"></i></div>
                            <div style="position: relative;" class="pop_chart">
                              <i class="las la-info-circle text-gray77 pl-2" placement="left" [ngbPopover]="info_tooltip_4"
                                triggers="mouseenter:mouseleave"></i>
                            </div>
                            <ng-template #info_tooltip_4>
                              <ng-container [ngTemplateOutlet]="tooltip_table"
                                [ngTemplateOutletContext]="{sign:node.profit_sign, current:node.f_current_profit, expected:node.f_expected_profit, current_percentage: node.current_profit_percentage, expected_percentage: node.expected_profit_percentage}">
                              </ng-container>
                            </ng-template>
                          </div>
                        </td>

            <td> <div [ngClass]="{'green-class': node.margin_sign == '+' , 'red-class':  node.margin_sign == '-'}" class="d-flex justify-content-end">{{node.f_margin_change}}
              <div><i class="pl-1 fa " [ngClass]="{'fa-caret-down': node.margin_sign == '-', 'fa-caret-up': node.margin_sign == '+'}"></i></div>
           <div style="position: relative;" class="pop_chart">
            <i class="las la-info-circle text-gray77 pl-2" placement="left" [ngbPopover]="info_tooltip_2"
            triggers="mouseenter:mouseleave"></i>
           </div>
            <ng-template #info_tooltip_2>
              <ng-container [ngTemplateOutlet]="tooltip_table"
                [ngTemplateOutletContext]="{sign:node.margin_sign, current:node.f_current_margin, expected:node.f_expected_margin, current_percentage: node.current_margin_percentage, expected_percentage: node.expected_margin_percentage}">
              </ng-container>
            </ng-template>
          </div></td>
          <td>
            <div [ngClass]="{'green-class': node.units_sign == '+' , 'red-class':  node.units_sign == '-'}" class="d-flex justify-content-end ">
              {{node.f_units_change}}
              <div>
                <i class="pl-1 fa "
                  [ngClass]="{'fa-caret-down': node.units_sign == '-', 'fa-caret-up': node.units_sign == '+'}"></i>
              </div>
              <div style="position: relative;" class="pop_chart">
                <i class="las la-info-circle text-gray77 pl-2 " placement="left" [ngbPopover]="info_tooltip_1"
                  triggers="mouseenter:mouseleave"> </i>
              </div>
              <div>
                <ng-template #info_tooltip_1>
                  <ng-container [ngTemplateOutlet]="tooltip_table"
                    [ngTemplateOutletContext]="{sign:node.units_sign, current:node.f_current_units, expected:node.f_expected_units, current_percentage: node.current_units_percentage, expected_percentage: node.expected_units_percentage}">
                  </ng-container>
                </ng-template>
              </div>
            </div>
          </td>

          </tr>
          <ng-container *ngIf="node.child.length && node.expand">
            <ng-template ngFor [ngForOf]="node.child| orderBy: current_sort_order.field:current_sort_order.sortorder " [ngForTemplate]="nodeTemplateRef">
            </ng-template>
          </ng-container>
</ng-template>
<ng-template #tooltip_table let-sign="sign" let-current='current' let-expected='expected' let-current_percentage='current_percentage' let-expected_percentage='expected_percentage'>
  <div style="min-width:235px">
    <div class="d-flex pb-1 align-items-center">
      <div class="progress price-progress progress-striped active bg-gray95" style="min-width: 235px;margin-top: 1.2em;">
        <div class="bar-color1" [ngStyle]="{'width': current_percentage + '%'}"></div>
      </div>
      <div class="bar-left-info pr-2 currentbar_left_value">Current</div>
      <div class="bar-right-info pl-2 currentbar_right_value">{{current}}</div>
    </div>
    <div class="d-flex align-items-center">
      <div class="progress price-progress progress-striped active bg-gray95" style="min-width: 235px;margin-top: 2em;">
        <div [ngClass]="{'bar-color2': sign == '-', 'bar-color4': sign == '+'}" [ngStyle]="{'width': expected_percentage + '%'}"></div>
      </div>
      <span class="bar-left-info pr-2 suggestedbar_left_value">Suggested</span>
      <span class="bar-right-info pl-2 suggestedbar_right_value">{{expected}}</span>
    </div>
  </div>
</ng-template>

